/***************************************************************************
                          ColorSchemeInterface.h  -  description
                             -------------------
    begin                : Son Mai 11 2003
    copyright            : (C) 2003 by Thomas Dreibholz
    email                : dreibh@exp-math.uni-essen.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COLORSCHEMEINTERFACE_H
#define COLORSCHEMEINTERFACE_H

#include <qptrlist.h>


/**
  *@author Thomas Dreibholz
  */
class ColorSchemeInterface {
   public:
   ColorSchemeInterface();
   virtual ~ColorSchemeInterface();
   virtual const char* getName() = 0;
   virtual const char* getSaveIdentifier() = 0;
   virtual void configure(unsigned int* maxIterations);
   virtual unsigned int getColor(const unsigned int value) = 0;

   static ColorSchemeInterface* getColorScheme(const unsigned int index);

   protected:
   unsigned int* MaxIterations;

   private:
   static QPtrList<ColorSchemeInterface> ColorSchemeList;
};

#endif

