/***************************************************************************
                          fractalbuffer.h  -  description
                             -------------------
    begin                : Sam Mai 10 2003
    copyright            : (C) 2003 by Thomas Dreibholz
    email                : dreibh@exp-math.uni-essen.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FRACTALBUFFER_H
#define FRACTALBUFFER_H


#include <stdio.h>


/**
  *@author Thomas Dreibholz
  */

class FractalBuffer
{
   public:
   FractalBuffer();
   ~FractalBuffer();
   bool reset(const unsigned int width, const unsigned int height);
   void clear();
   inline unsigned int getPoint(const unsigned int x, const unsigned int y) {
      unsigned int pos = y * Width + x;
      if(pos < BufferSize) {
         return(Buffer[pos]);
      }
      printf("ERROR: FractalBuffer::getPoint() - Illegal position: x=%d y=%d in w=%d h=%d\n",x,y,Width,Height);
      return(~0);
   }
   inline void setPoint(const unsigned int x, const unsigned int y, const unsigned int value) {
      unsigned int pos = y * Width + x;
      if(pos < BufferSize) {
         Buffer[pos] = value;
      }
      else {
         printf("ERROR: FractalBuffer::setPoint() - Illegal position: x=%d y=%d in w=%d h=%d\n",x,y,Width,Height);
      }
   }

   private:
   unsigned int* Buffer;
   unsigned int  BufferSize;
   unsigned int  Width;
   unsigned int  Height;
};

#endif
