/***************************************************************************
                          optionsdialog.h  -  description
                             -------------------
    begin                : Mon Sep 1 2003
    copyright            : (C) 2003 by Thomas Dreibholz
    email                : dreibh@exp-math.uni-essen.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OPTIONSDIALOG_H
#define OPTIONSDIALOG_H

#include <qwidget.h>
#include <qdialog.h>
#include <qlistview.h>
#include "configentry.h"
#include <qptrlist.h>



/**
  *@author Thomas Dreibholz
  */

class OptionsDialog : public QDialog  {
   Q_OBJECT
public: 
	OptionsDialog(QWidget *parent=0, const char *name=0, QPtrList<ConfigEntry> *configEntries = 0);
	~OptionsDialog();

private:

    QListView *m_ListView;
    QPtrList<ConfigEntry> *m_ConfigEntries;

    
public slots:
    void slotClicked (QListViewItem*);
    void slotItemRenamed ( QListViewItem * item, int col, const QString & text );
    void slotAccept();
    
};

#endif
